<?
/**
 * VoiceOne Settings/Queues/edit
 *
 * Frontend to provide access to the queue system in voiceone.
 * @package voiceone
 * @subpackage  settings_queues
 */
  include ("../../../../admin/config/cfg.php");
  global $cwlang;
  require_once("$absBasePath/lib/xajax/xajax.inc.php"); 
  sajax_init();
  
  //================ XAJAX ================
  function processFormData($formData){
    global $asterisk,$cwlang,$relBasePath;
    // Instantiate the xajaxResponse object
    $objResponse = new xajaxResponse();
    //extract form params
    $queue=$formData["queue"];
    $id=$queue["id"];
    $name=$queue["name"];
    $membersArr=$queue["member"];
    $imgErr="<img src=\"".$relBasePath."/public/img/shutdown.png\" alt=\"error\">";
    // Retrieve all accounts
    $queueArr=$asterisk->getQueue(0);
    if(is_array($queueArr)){
      foreach($queueArr as $q){
        if($id==$q["id"]) continue;
        $qNameArr[]=$q["name"];
      }
    }
    // Check Name ((not null)&&(unique)&&(no spaces))
    $nameErr=false;
    if($name=="") { 
      //name cannot be null
      $errOut[]= $cwlang["queue"]["nameNoNull"];
      $objResponse->addAssign("nameErr","innerHTML",$imgErr);
      $nameErr=true;  
    }else if((is_array($qNameArr))&&(in_array($name,$qNameArr))){
      //name must be unique
      $errOut[]= $cwlang["queue"]["nameAlreadyExists"];
      $objResponse->addAssign("nameErr","innerHTML",$imgErr);
      $nameErr=true;
    }
    if($nameErr===false) $objResponse->addAssign("nameErr","innerHTML","");
		// Check Members (not null)
    $membersErr=false;
    if((!is_array($membersArr))||(count($membersArr)<1)){
      //members list cannot be null
      $errOut[]= $cwlang["queue"]["memberNoNull"];
      $objResponse->addAssign("membersErr","innerHTML",$imgErr);
      $membersErr=true;  
    }
    if($membersErr===false) $objResponse->addAssign("membersErr","innerHTML","");
    // Process Form
    if(isset($errOut)){
      $error="<div class=\"AlertBad\"><ul>";
      foreach($errOut as $err) $error.="<li>".$err."</li>";
      $error.="</ul></div>";
      $objResponse->addAssign("alert","innerHTML",$error);
      $objResponse->addAssign("loading","innerHTML","");
    }else{
      $objResponse->addAssign("loading","innerHTML",""); 
      $objResponse->addScript(" document.getElementById('mainform').submit(); ");
    }
    // Return the xajaxResponse object
    return $objResponse->getXML();  
  }
  $xajax = new xajax();
  $xajax->registerFunction("processFormData");
  $xajax->processRequests();
  
  //================== POST ====================
  if (count($_POST)>0) {
    $data=$_POST["queue"];
    $entry=array(
      "id" => $data["id"],
      "name" => $data["name"]
    );    
    if(is_array($data["member"])){
      foreach($data["member"] as $g) $entry["member"][]=$g;
    }
    //add options to the entry
    foreach ($_POST as $k=>$v) {
      if (substr($k,0,7)=="status_") {
        $k=substr($k,7);
        if ($v=="1") {
          $o["key"]=$k; 
          $o["value"]=$_POST["option_".$k];
          $options[]=$o;
        }
      }
    }
    $entry["options"]=$options;
    $ret=$asterisk->putQueue($entry);
    if ($ret>0) {
      $alert="<div class=\"AlertGood\">".$cwlang["queue"]["alertModGood"]."</div>";
      $_GET["id"]=$ret;
    } else $alert="<div class=\"AlertBad\">".$cwlang["queue"]["alertModBad"]."</div>";

    goToMainPage($alert);
  }

  //================ PAGE LOGIC ================
  //retrieve the queue informations
  if ($_GET["id"]!="") {
    $queue=$asterisk->getQueue($_GET["id"]);
    $queueName=$queue[0]["name"];
    $queueMember=$queue[0]["member"];
    $selOptionArr=array();
    if(is_array($queue[0]["options"])){
      foreach($queue[0]["options"] as $opt){
        $selOptionArr[$opt["key"]]=$opt["value"];
      }
    }
    $title=$cwlang["queue"]["modifyQueue"].$queueName;
  }else{
    $title=$cwlang["queue"]["newQueue"];
  }
  //retrieve the list of agents
  $ret=$asterisk->getAgent(0);
  if ($err=$asterisk->getError()) die("Error: $err");
  $count=0;
  if (is_array($ret)) {
    foreach($ret as $v) {
      $id=$v["id"];
      $clientArr=getClient($v["client"]);
      $client=$clientArr[0];
      $name=$client["name"]." ".$client["surname"]." &lt;".$client["extension"]."&gt;";
      $icon="<img src=\"$relBasePath/public/img/agent_on.gif\" />";
      if((is_array($queueMember))&&(in_array($id, $queueMember))) $chk="checked='checked'"; else $chk=""; 
      $html.="<td> <input type=\"checkbox\" name=\"queue[member][]\" value=\"$id\" $chk/> $icon $name </td>\n";
      if ((++$count)%2==0) $html.="</tr><tr>\n";
    }
  }else $html.="<td><span class=\"help\">".$cwlang["exten"]["emptyMemberList"]."</span></td>\n";
  //get the configuration option
  $optionArr=$asterisk->getConfOption(0,"QUEUES",SECTION_DEFAULT);
  $html_option=getOption($optionArr,$selOptionArr,false,"");
  
  //================ MAIN CONTENTS ================
  ob_start();
  $xajax->printJavascript("../../../../admin/lib/xajax/");
  ?>
  <div class="SectionHeader">
    <div id="loading" style="float: right;"></div>
    <h1><?=$title?></h1>
    <h3>
      <a href="../" class="admin" ><?=$cwlang["exten"]["return"]?></a> 
    </h3>
  </div>
  <div id="alert"></div>
  <div id="basic_form">
    <form id="mainform" action="<?=$PHP_SELF?><? if ($_GET['id']!="") echo "?id=".$_GET['id']; ?>" method="post">
      <div id="client_form" >
        <h2><?=$cwlang["queue"]["titleForm"]?></h2>
        <p class="blockintro"><?=$cwlang["queue"]["textForm"]?></p>
        <div class="block">
          <dl>
            <!-- Name -->
            <dt class="required"><label for="queue[name]"><?=$cwlang["queue"]["name"]?>:</label></dt>
            <dd><input type="text" size="25" maxlength="30" id="queue[name]" name="queue[name]" value="<?=$queueName?>" /><span id="nameErr"></span> <?=$cwlang["queue"]["nameExample"]?></dd>    
            <!-- Members -->
            <dt class="required"><label for="queue[members]"><?=$cwlang["queue"]["members"]?>:</label></dt>
            <dd>
              <table style="width: 70%; color: black;">
                <tr><?=$html?></tr>
              </table>
              <span id="membersErr" style="float: right;"></span>
            </dd>
          </dl>
          <!-- Advanced Options -->
          <table><?=$html_option?></table>
        </div>
      </div>        
      <div class="action">
        <?if ($_GET["id"]!="") {?><input type="hidden" name="queue[id]" value="<?=$_GET['id']?>" /><?}?>
        <a href="#"><img src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-cancel.gif" alt="Cancel" onclick="location.href='../'; return false;"/></a>
        <a href="#"><img src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-save.gif" alt="Save" onclick=" document.getElementById('alert').innerHTML=''; xajax_processFormData(xajax.getFormValues('mainform')); "/></a>
      <!--
        <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-cancel.gif" alt="Annulla" onclick="location.href='../'; return false;"/>
        <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-save.gif" alt="Salva" />
       -->
      </div>
    </form>
  </div>  
  
  <?
  $contents=ob_get_contents();
  ob_end_clean();

  //================ SIDEBAR ================
  ob_start(); 
  ?>
    <div class="Sidebar">
      <?$sel="queue";include("../../sidebar.php");?>
      <h1><?=$cwlang["tech"]["sidebarTitle"]?></h1>
      <p><?=$cwlang["tech"]["sidebarDesc"]?></p>
    </div>
  <?  
  $sidebar=ob_get_contents();
  ob_end_clean();

  //================ SETTINGS ================
  $smarty->assign("section", "queue");
  $smarty->assign("subsection", "");
  $smarty->assign("templateType", "TwoColLeft");  //OneCol, TwoColLeft, TwoColRight
  $smarty->assign("contents", $contents);
  $smarty->assign("sidebar", $sidebar);
  $smarty->display('settings.tpl');
  
?>

