<?
/**
 * VoiceOne Settings/Provider/account
 *
 * Frontend to provide access to the provider's accounts in voiceone.
 * @package voiceone
 * @subpackage  settings_provider
 */
  include ("../../../../admin/config/cfg.php");
  global $cwlang, $cwLanguage;
 	require_once("$absBasePath/lib/xajax/xajax.inc.php"); 
 	sajax_init();

  //================ XAJAX ================
	function showCid($acc_id){
    global $asterisk,$cwlang;
    // Instantiate the xajaxResponse object
    $objResponse = new xajaxResponse();
		// Build response
    if($acc_id!=""){
      $ret=$asterisk->getProviderAccount($acc_id,0);
      if ($err=$asterisk->getError()) die("Error: $err");
      $cid_force=$ret[0]["force_cid"];
      $cid_clir=$ret[0]["clir"];
      $cid_number=$ret[0]["cid_number"];
      $cid_name=$ret[0]["cid_name"];
      $cid_appexten=$ret[0]["cid_appexten"];
    }
    ob_start();
    ?>
        <dl>
          <dt class="required"><label for="cid[cid_name]"><?=$cwlang["isdngrp"]["cidName"]?>:</label></dt>
          <dd><input type="text" size="25" maxlength="20" id="cid[cid_name]" name="cid[cid_name]" value="<?=$cid_name?>" /> <?=$cwlang["isdngrp"]["cidNameDesc"]?></dd>
          <dt class="required"><label for="cid[cid_number]"><?=$cwlang["isdngrp"]["cidNumber"]?>:</label></dt>
          <dd><input type="text" size="25" maxlength="100" id="cid[cid_number]" name="cid[cid_number]" value="<?=$cid_number?>" /> <?=$cwlang["isdngrp"]["cidNumberDesc"]?></dd>
          <dt class="required"><label for="cid[cid_appexten]"><?=$cwlang["isdngrp"]["cidAppExten"]?>:</label></dt>
          <dd><input type="checkbox" id="cid[cid_appexten]" name="cid[cid_appexten]" value="1" <?if ($cid_appexten==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidAppExtenDesc"]?></dd>
          <dt class="required"><label for="cid[force_cid]"><?=$cwlang["isdngrp"]["cidForceCid"]?>:</label></dt>
          <dd><input type="checkbox" id="cid[force_cid]" name="cid[force_cid]" value="1" <?if ($cid_force==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidForceDesc"]?></dd>
        </dl>
    <?
    $html=ob_get_contents();
    ob_end_clean();  
    // Return the xajaxResponse object
		$objResponse->addAssign("callerid","innerHTML",$html);
    return $objResponse->getXML(); 
  }
  function hideCid(){
    // Instantiate the xajaxResponse object
    $objResponse = new xajaxResponse();
		// Build response
    $html="";
    // Return the xajaxResponse object
		$objResponse->addAssign("callerid","innerHTML",$html);
    return $objResponse->getXML(); 
  } 
	function roll(){
    global $relBasePath,$cwlang;
    // Instantiate the xajaxResponse object
    $objResponse = new xajaxResponse();
    // Build response
    $html=" <img src=\"".$relBasePath."public/img/ico-progress.gif"."\" alt=\"loading\" /><span>".$cwlang["exten"]["loading"]."</span>";
    $objResponse->addAssign("loading","innerHTML",$html);
    // Return the xajaxResponse object
    return $objResponse->getXML(); 
  }
  function processFormData($formData){
    global $asterisk,$cwlang,$relBasePath;
    // Instantiate the xajaxResponse object
    $objResponse = new xajaxResponse();
    // Extract form's params
    $account=$formData["res"];
    if($account["provider"]!="") $provider=$account["provider"];
    else $provider=$account["provider_hidden"];
    $id=$account["id"];
    $name=$account["name"];
    $username=$account["username"];
    $password=$account["password"];
    $confirm=$account["confirm"];
    $allow_in=$account["allow_in"];
    $speeddial=$account["speeddial"];
    $oldSpeeddial=$account["oldSpeeddial"];
    $contact_extension=$account["contact_extension"];
    $phonenumberArr=$formData["phonenumber"];
    $imgErr="<img src=\"".$relBasePath."/public/img/shutdown.png\" alt=\"error\">&nbsp;&nbsp;";
    // Retrieve all accounts
    $providerArr=$asterisk->getProvider(0);
    if(is_array($providerArr)){
      foreach($providerArr as $p){
        if(is_array($p["accounts"])){
          foreach($p["accounts"] as $a){
            if($id==$a["id"]) continue;
            $aNameArr[]=$a["name"];
            if(($a["provider"]==$provider)&&(is_array($a["numbers"]))){
              foreach($a["numbers"] as $num) $aNumberArr[]=$num;
            }
          }
        }
      }
    }
    // Retrieve Extensions
    $extensionArr=$asterisk->getExtension(0);
    if(is_array($extensionArr)){
      foreach($extensionArr as $ext){
        if(($id==$ext["entity_id"])||($oldSpeeddial."*"==$ext["extension"])) continue;
        $extNumberArr[]=$ext["extension"];
      }
    }
    // Check Name ((not null)&&(unique)&&(no spaces))
    $nameErr=false;
    if($name=="") { 
      //name cannot be null
      $errOut[]= $cwlang["provider"]["nameNoNull"];
      $objResponse->addAssign("nameErr","innerHTML",$imgErr);
      $nameErr=true;  
    }else if((is_array($aNameArr))&&(in_array($name,$aNameArr))){
      //name must be unique
      $errOut[]= $cwlang["provider"]["nameAlreadyExists"];
      $objResponse->addAssign("nameErr","innerHTML",$imgErr);
      $nameErr=true;
    }else{
      //name must have no spaces
      for($i=0; $i<strlen($name); $i++){ 
        $ch=ord($name[$i]);
        if($ch==32){
          $errOut[]=$cwlang["provider"]["nameNoSpaces"];
          $objResponse->addAssign("nameErr","innerHTML",$imgErr);
          $nameErr=true;
          break;
        }
        if($ch==45){
          $errOut[]=$cwlang["provider"]["nameNoCharInit"]."\"".$name[$i]."\".".$cwlang["provider"]["nameNoCharEnd"];
          $objResponse->addAssign("nameErr","innerHTML",$imgErr);
          $nameErr=true;
          break;
        }
      }
    }
    if($nameErr===false) $objResponse->addAssign("nameErr","innerHTML","");
    // Check Username ((not null)and(not spaces))
    $usernameErr=false;
    if($username==""){
      //account username cannot be null
      $errOut[]=$cwlang["provider"]["usernull"];
      $objResponse->addAssign("usernameErr","innerHTML",$imgErr);
      $usernameErr=true;
    }else{
      //username must have no spaces
      for($i=0; $i<strlen($username); $i++){
        $ch=ord($username[$i]);
        if($ch==32){
          $errOut[]=$cwlang["provider"]["usernameNoSpaces"];
          $objResponse->addAssign("usernameErr","innerHTML",$imgErr);
          $usernameErr=true;
          break;
        }
      }
    }
    if($usernameErr===false) $objResponse->addAssign("usernameErr","innerHTML","");
    // Check Account Password ((no null if register)&&(==confirm)&&(no spaces))
    $passwordErr=false;
    if(($allow_in==1)&&($password=="")){
      //account password cannot be null
      $errOut[]=$cwlang["provider"]["pwdnull"];
      $objResponse->addAssign("passwordErr","innerHTML",$imgErr);
      $passwordErr=true;
    }else if($password!=$confirm){
      //account password must be equal to confirm
      $errOut[]=$cwlang["provider"]["pwderr"];
      $objResponse->addAssign("passwordErr","innerHTML",$imgErr);
      $objResponse->addAssign("confirmErr","innerHTML",$imgErr);
      $passwordErr=true;
    }else{
      //account password must have no spaces
      for($i=0; $i<strlen($password); $i++){ 
        $ch=ord($password[$i]);
        if($ch==32){
          $errOut[]=$cwlang["provider"]["pwdNoSpaces"];
          $objResponse->addAssign("passwordErr","innerHTML",$imgErr);
          $passwordErr=true;
          break;
        }
      }
    }
    if($passwordErr===false){
      $objResponse->addAssign("passwordErr","innerHTML","");
      $objResponse->addAssign("confirmErr","innerHTML","");
    }
    // Check Contact Extension ((null)or(not spaces))
    $contactErr=false;
    if($contact_extension!=""){
      //contact extension must have no spaces
      for($i=0; $i<strlen($contact_extension); $i++){ 
        $ch=ord($contact_extension[$i]);
        if($ch==32){
          $errOut[]=$cwlang["provider"]["contactNoSpaces"];
          $objResponse->addAssign("contactErr","innerHTML",$imgErr);
          $contactErr=true;
          break;
        }
      }
    }
    if($contactErr===false) $objResponse->addAssign("contactErr","innerHTML","");
    // Check Speeddial((null)or ((numeric)and(unique)) )
    $speedErr=false;
    if($speeddial!=""){
      //speeddial must be numeric
      for($i=0; $i<strlen($speeddial); $i++){ 
        $ch=ord($speeddial[$i]);
        if(!((($ch>47)&&($ch<58)))){
          $errOut[]=$cwlang["provider"]["speedNumOnly"];
          $objResponse->addAssign("speedErr","innerHTML",$imgErr);
          $speedErr=true;
          break;
        }
      }
      if($speedErr===false){
        //speeddial must be unique
        if((is_array($extNumberArr))&&(in_array($speeddial."*",$extNumberArr))){
          $errOut[]=$cwlang["provider"]["speedAlreadyDef"];
          $objResponse->addAssign("speedErr","innerHTML",$imgErr);
          $speedErr=true;
        }
      }
    }
    if($speedErr===false) $objResponse->addAssign("speedErr","innerHTML","");
    // Check Phonenumbers ((null)or((unique in provider)&&(contain cantact extension))
    $phonenumberErr=false;
    if(is_array($phonenumberArr)){
      //Phonenumbers must be unique in provider
      foreach($phonenumberArr as $number){
        if((is_array($aNumberArr))&&(in_array($number,$aNumberArr))){
          $errOut[]=$cwlang["provider"]["numberAlreadyDef"];
          $objResponse->addAssign("phonenumberErr","innerHTML",$imgErr);
          $phonenumberErr=true;
          break;
        }
      }
    }else if($contact_extension!=""){
      //Phonenumbers must contain cantact extension
      if((!(is_array($phonenumberArr)))||(!(in_array($contact_extension,$phonenumberArr)))){
        $errOut[]=$cwlang["provider"]["numberNotEqCE"];
        $objResponse->addAssign("phonenumberErr","innerHTML",$imgErr);
        $phonenumberErr=true; 
      }
    }
    if($phonenumberErr===false) $objResponse->addAssign("phonenumberErr","innerHTML","");
    // Process Form
    if(isset($errOut)){
      $error="<div class=\"AlertBad\"><ul>";
      foreach($errOut as $err) $error.="<li>".$err."</li>";
      $error.="</ul></div>";
      $objResponse->addAssign("alert","innerHTML",$error);
      $objResponse->addAssign("loading","innerHTML","");
    }else{
      $objResponse->addAssign("loading","innerHTML",""); 
      $objResponse->addScript(" document.getElementById('mainform').submit(); ");
    }
    // Return the xajaxResponse object
    return $objResponse->getXML();  
  }
  $xajax = new xajax();
	$xajax->registerFunction("showCid");
  $xajax->registerFunction("hideCid");
  $xajax->registerFunction("roll");
  $xajax->registerFunction("processFormData");
  $xajax->processRequests();

  //================= POST  ==================
  if (count($_POST)>0) {
    $data=$_POST["res"];
    $entry=Array(
            "id"        => $data["id"],
            "name"      => $data["name"],
            "speeddial" => $data["speeddial"],
            "username"  => $data["username"], 
            "password"  => $data["password"],  
            "did"       => $_POST["did"],
            "allow_in"  => $data["allow_in"],
            "contact_extension" => $data["contact_extension"]
    );
    //provider host and port
    if (isset($data["provider"])&&($data["provider"]!="")) $entry["provider"]=$data["provider"];
    else $entry["provider"]=$data["provider_hidden"];
    $entry["port"]=$data["port"];
		//add the phonenumbers
    if (is_array($_POST["phonenumber"])) 
    foreach($_POST["phonenumber"] as $pn) $entry["numbers"][]=trim($pn);		
    // add cid setting
    $cid=$_POST["cid"];
    if($cid["passthrough"]==1) $entry["enable_cid"]=0;
    else $entry["enable_cid"]=1;
    $entry["force_cid"]=$cid["force_cid"];
    $entry["clir"]=$cid["clir"];
    $entry["cid_number"]=$cid["cid_number"];
    $entry["cid_name"]=$cid["cid_name"];
    $entry["cid_appexten"]=$cid["cid_appexten"];
    //add options to the entry
    foreach ($_POST as $k=>$v) {
      if (substr($k,0,7)=="status_") {
        $k=substr($k,7);
        if ($v=="1") {
          $o["key"]=$k; 
          $o["value"]=$_POST["option_".$k];
          $options[]=$o;
        }
      }
    }
    $entry["options"]=$options;
    //put account
    $ret=$asterisk->putProviderAccount($entry);
    if ($err=$asterisk->getError()) $alert="<div class=\"AlertBad\">ERROR: $err</div>";
    if ($ret>0) {
      $alert.="<div class=\"AlertGood\">".$cwlang["provider"]["alertDelGood"]."</div>";
      $_GET["id"]=$ret;
    } else $alert.="<div class=\"AlertBad\">".$cwlang["provider"]["alertDelBad"]."</div>";
    goToMainPage($alert);
  }
  //================ PAGE LOGIC ================
  // Modify exsisting account
  if (isset($_GET["id"]) and $_GET["id"]!="") {
    $id=$_GET["id"];
    $ret=$asterisk->getProviderAccount($id,0);
    if ($err=$asterisk->getError()) die("Error: $err");
    $v=$ret[0];
    $id=$v["id"];
    $name=$v["name"];
    $provider=$v["provider"];
    $port=$v["port"];
    $speeddial=$v["speeddial"];
    $rule=$v["rule"];
    $username=$v["username"];  
    $password=$v["password"];   
    $did=$v["did"];
    $optionsArr=$v["options"];
    $cid["enable_cid"]=$v["enable_cid"];
    if($cid["enable_cid"]==1) $passthrough==0; else $passthrough==1;
    $cid["force_cid"]=$v["force_cid"];
    $cid["clir"]=$v["clir"];
    $cid["cid_number"]=$v["cid_number"];
    $cid["cid_name"]=$v["cid_name"];
    $cid["cid_appexten"]=$v["cid_appexten"];
    $allow_in=$v["allow_in"];
    $contactExt=$v["contact_extension"];
    //create the phone number list
    if (is_array($v["numbers"])) {
      foreach($v["numbers"] as $n) $numbers.="<option value='$n'>$n</option>";
    }  
    //set allows
    if($allow_in==1) $checkAllowIn="checked=\"checked\""; else $checkAllowIn="";
    //set title
    $title=$cwlang["provider"]["modAccTitle"].$name;
  } 
  // New provider's account
  else if (isset($_GET["prov"]) and $_GET["prov"]!="") {
    $provider=$_GET["prov"];
    $checkAllowIn="checked=\"checked\"";
    //set title
    $title=$cwlang["provider"]["newAccTitle"];
  }
  // Error: No account id && No provider id
  else die;
  //get providers
  $ret=$asterisk->getProvider(0);
  if ($err=$asterisk->getError()) die("Error: $err");
  if (is_array($ret)){
    $disableProv="";
    foreach($ret as $p){
      $pid=$p["id"];
      $pname=$p["name"];
      if($pid==$provider){
        $providerList.="<option value=\"$pid\" selected=\"selected\">$pname</option>\n";
        $technology=$p["technology"];
        $disableProv="disabled=\"disabled\""; 
        if(strpos($p["port"],"-")){
          $portArr=split("-",$p["port"]);
          $port_current=$portArr[0];
          $port_end=$portArr[1];
          while(($port_current<=$port_end)&&($port_current<65537)){
            if($port_current==$port) $portList.="<option value=\"$port_current\" selected=\"selected\">$port_current</option>\n";
            $portList.="<option value=\"$port_current\" >$port_current</option>\n"; 
            $port_current++;
          }
          $disablePort="";
        }else{ 
          $portList.="<option value=\"".$p["port"]."\" selected=\"selected\">".$p["port"]."</option>\n"; 
        }  
      }else{
        $providerList.="<option value=\"$pid\">$pname</option>\n";
      }   
    }
  }
  //set default callerid in tech options
  if(!(isset($_GET["id"]) and $_GET["id"]!="")) {
    if($technology==SIP){
      $ret=$asterisk->getConfOption("","SIP",SECTION_DEFAULT);
      if(is_array($ret)){
        foreach($ret as $o){
          if($o["name"]=="callerid") $optionsArr[]=array("key" => $o["id"] , "value" => "null");
        }
      }
    }else if($technology==IAX2){
      $ret=$asterisk->getConfOption("","IAX2",SECTION_DEFAULT);
      if(is_array($ret)){
        foreach($ret as $o){
          if($o["name"]=="callerid") $optionsArr[]=array("key" => $o["id"] , "value" => "null");
        }
      }
    }
  } 
  
  //================ MAIN CONTENTS ================
  ob_start();
  $xajax->printJavascript("../../../../admin/lib/xajax/"); 
  ?>
  <div class="SectionHeader">
    <div id="loading" style="float: right;"></div>
    <h1><?=$title?></h1>
    <h3><a href="../" class="admin" ><?=$cwlang["provider"]["return"]?></a></h3>
  </div>
  <div id="alert"></div>
  <div id="basic_form">
    <form id="mainform" action="<?=$PHP_SELF?>?id=<?=$_GET["id"]?>" method="post"  onSubmit="return selectAll(getElementById('phonenumber'))">      
	    <!-- Authentication -->
      <h2><?=$cwlang["provider"]["authTitle"]?></h2>
      <p class="blockintro"><?=$cwlang["provider"]["authTitleDesc"]?></p>
      <div class="block">
        <table cellpadding="0" cellspacing="0">
          <tr>
            <td valign="top">
              <dl>
                <dt class="required"><label for="res[name]"><?=$cwlang["provider"]["accName"]?>:</label></dt>
                <dd><input type="text" size="25" maxlength="100" id="res[name]" name="res[name]" value="<?=$name?>" /><span id="nameErr"></span><span class="help"><?=$cwlang["provider"]["accNameHelp"]?></span></dd>
                <dt class="required"><label for="res[provider]"><?=$cwlang["provider"]["accProvider"]?>:</label></dt>
                <dd><select id="res[provider]" name="res[provider]" size="1" style="width: 153px;" length="20" <?=$disableProv?> > <?=$providerList?></select><span class="help"><?=$cwlang["provider"]["accProviderHelp"]?></span>
                    <input type="hidden" id="res[provider_hidden]" name="res[provider_hidden]" value="<?=$provider?>" /></dd>
                <dt class="required"><label for="res[port]"><?=$cwlang["provider"]["port"]?>:</label></dt>
                <dd><select id="res[port]" name="res[port]" size="1" style="width: 153px;" length="20" <?=$disablePort?> ><?=$portList?></select><span class="help"><?=$cwlang["provider"]["accPortHelp"]?></span>
              </dl>
            </td>
            <td valign="top">
              <dl>
                <dt class="required"><label for="res[username]"><?=$cwlang["provider"]["username"]?>:</label></dt>
                <dd><input type="text" size="25" maxlength="100" id="res[username]" name="res[username]" value="<?=$username?>" /><span id="usernameErr"></span><span class="help"><?=$cwlang["provider"]["usernameHelp"]?></span></dd>
                <dt class="required"><label for="res[password]"><?=$cwlang["provider"]["password"]?>:</label></dt>
                <dd><input type="password" size="25" maxlength="20" id="res[password]" name="res[password]" value="<?=$password?>" /><span id="passwordErr"></span><span class="help"><?=$cwlang["provider"]["passwordHelp"]?></span></dd>
      					<dt class="required"><label for="res[confirm]"><?=$cwlang["provider"]["confirm"]?>:</label></dt>
                <dd><input type="password" size="25" maxlength="20" id="res[confirm]" name="res[confirm]" value="<?=$password?>" /><span id="confirmErr"></span><span class="help"><?=$cwlang["provider"]["confirmHelp"]?></span></dd>
                <dt class="required"><label for="res[register]"><?=$cwlang["provider"]["register"]?>:</label></dt>
                <dd><input type="checkbox" id="res[allow_in]" name="res[allow_in]" value="1" <?=$checkAllowIn?> /><span class="help"><?=$cwlang["provider"]["allowIncoming"]?></span></dd>
              </dl>
            </td>
          </tr>
        </table>
      </div>
      <!-- Settings -->
      <h2><?=$cwlang["provider"]["accsetTitle"]?></h2>
      <p class="blockintro"><?=$cwlang["provider"]["accsetTitleDesc"]?></p>
      <div class="block"> 
        <dl>
				  <dt class="required"><label for="res[speeddial]"><?=$cwlang["provider"]["SpeedDial"]?>:</label></dt>
          <dd>
            <input type="text" size="19" maxlength="50" id="res[speeddial]" name="res[speeddial]" value="<?=$speeddial?>" /><big><span style="color: #000000;"> *</span></big><span id="speedErr">&nbsp;</span><span class="help"><?=$cwlang["provider"]["speedHelp"]?></span>
            <input type="hidden" maxlength="50" id="res[oldSpeeddial]" name="res[oldSpeeddial]" value="<?=$speeddial?>" />  
          </dd>
          <? if($technology==SIP){ ?>
				    <dt class="required"><label for="res[contact_extension]"><?=$cwlang["provider"]["contactExt"]?>:</label></dt>
            <dd><input type="text" size="22" maxlength="50" id="res[contact_extension]" name="res[contact_extension]" value="<?=$contactExt?>" /><span id="contactErr"></span> <span class="help"><?=$cwlang["provider"]["contactExtHelp"]?></span></dd>
          <? } ?>
        </dl>
        <? if($technology==IAX2){ ?>
				  <input type="hidden" id="res[contact_extension]" name="res[contact_extension]" value="" />
        <? } ?>
        <table style="margin-left: 24px;">
          <tr>
            <td class="required"><label for="number"><?=$cwlang["provider"]["phoneNumber"]?>:</label></td>
            <td class="required"><?=$cwlang["provider"]["phoneNumberAdded"]?></td>
          </tr>
          <tr>
            <td valign="top">
              <input type="text" size="25" maxlength="100" id="number" name="number" value="" />
              <input type="button" value="+" onclick="addOption(getElementById('phonenumber'),document.getElementById('number').value);document.getElementById('number').value='';" title="<?=$cwlang["provider"]["addButtonHelp"]?>">
              <div class="help"><?=$cwlang["provider"]["phoneNumberDesc"]?></div>
              <div style="margin: 0.5em 0"><strong><?=$cwlang["provider"]["DID"]?>:</strong> <?=showDid($did);?></div>
            </td>
            <td>
              <select name="phonenumber[]" size="4" onchange="saved = false" ondblclick="editOptions(this)" multiple style="float: left" id="phonenumber">
                <?=$numbers?>
              </select>
              <input type="button" value="<?=$cwlang["provider"]["editButton"]?>" onclick="editOptions(getElementById('phonenumber'))" title="<?=$cwlang["provider"]["editButtonHelp"]?>" />
              <input type="button" value="<?=$cwlang["provider"]["delButton"]?>" onclick="deleteOptions(getElementById('phonenumber'))" title="<?=$cwlang["provider"]["delButtonHelp"]?>" />
              <span id="phonenumberErr"></span>
            </td>
          </tr>
        </table>
      </div>
      <!-- Caller Id -->
      <h2><?=$cwlang["isdngrp"]["cidTitle"]?></h2>
      <p class="blockintro"><?=$cwlang["isdngrp"]["cidTitleDesc"]?></p>
      <div class="block">
        <div>
          <dl>
            <dt class="required"><label for="cid[clir]"><?=$cwlang["isdngrp"]["cidClir"]?>:</label></dt>
            <dd><input type="checkbox" id="cid[clir]" name="cid[clir]" value="1" <?if ($cid["clir"]==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidClirDesc"]?></dd>
            <dt class="required"><label for="cid[passthrough]"><?=$cwlang["isdngrp"]["cidPassThrough"]?>:</label></dt>
            <?if(isset($_GET["id"])) {?><dd><input type="checkbox" id="cid[passthrough]" name="cid[passthrough]" value="1" onclick="if(this.checked){xajax_hideCid();}else{xajax_showCid(document.getElementById('res[id]').value);}" <?if ($passthrough==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidPassThroughDesc"]?></dd>
            <?}else{?><dd><input type="checkbox" id="cid[passthrough]" name="cid[passthrough]" value="1" onclick="if(this.checked){xajax_hideCid();}else{xajax_showCid('');}" <?if ($passthrough==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidPassThroughDesc"]?></dd><? } ?>
          </dl>  
        </div>
        <div id="callerid">
          <?if($passthrough==0) {?>
          <dl>
            <dt class="required"><label for="cid[cid_name]"><?=$cwlang["isdngrp"]["cidName"]?>:</label></dt>
            <dd><input type="text" size="25" maxlength="20" id="cid[cid_name]" name="cid[cid_name]" value="<?=$cid['cid_name']?>" /> <?=$cwlang["isdngrp"]["cidNameDesc"]?></dd>
            <dt class="required"><label for="cid[cid_number]"><?=$cwlang["isdngrp"]["cidNumber"]?>:</label></dt>
            <dd><input type="text" size="25" maxlength="100" id="cid[cid_number]" name="cid[cid_number]" value="<?=$cid['cid_number']?>" /> <?=$cwlang["isdngrp"]["cidNumberDesc"]?></dd>
            <dt class="required"><label for="cid[cid_appexten]"><?=$cwlang["isdngrp"]["cidAppExten"]?>:</label></dt>
            <dd><input type="checkbox" id="cid[cid_appexten]" name="cid[cid_appexten]" value="1" <?if ($cid["cid_appexten"]==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidAppExtenDesc"]?></dd>
            <dt class="required"><label for="cid[force_cid]"><?=$cwlang["isdngrp"]["cidForceCid"]?>:</label></dt>
            <dd><input type="checkbox" id="cid[force_cid]" name="cid[force_cid]" value="1" <?if ($cid["force_cid"]==1) echo "checked=\"checked\""; ?> /> <?=$cwlang["isdngrp"]["cidForceDesc"]?></dd>
          </dl>
          <? } ?>
        </div>
      </div>   
      <!-- Tech Options -->
      <? echo listOption($js, $technology, $optionsArr,false,false,RULE_INCOMING,false,true);?>	 
	    <!-- Input Buttons -->
      <div class="action">
        <input type="hidden" id="res[id]" name="res[id]" value="<?=$id?>" />
        <a href="#"><img src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-cancel.gif" alt="Cancel" onclick="location.href='../'; return false;"/></a>
        <a href="#"><img src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-save.gif" alt="Save" onclick=" selectAll(getElementById('phonenumber')); document.getElementById('alert').innerHTML=''; xajax_processFormData(xajax.getFormValues('mainform')); "/></a>
        <!-- <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-cancel.gif" alt="Cancel" onclick="location.href='../'; return false;"/>
        <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-save.gif" alt="Save" /> -->
      </div>
    </form>
  </div>  
  
  <?
  $contents=ob_get_contents();
  ob_end_clean();
  //================ SIDEBAR ================
  ob_start(); 
  ?>
    <div class="Sidebar">
      <?$sel="providers";include("../../sidebar.php");?>
      <h1><?=$cwlang["provider"]["accountSidebarTitle"]?></h1>
      <p><?=$cwlang["provider"]["accountSidebarDesc"]?></p>
    </div>
  <?  
  $sidebar=ob_get_contents();
  ob_end_clean();

  //================ SETTINGS ================
 	sajax_handle_client_request();
  $smarty->assign("section", "providers");
  $smarty->assign("subsection", "");
  $smarty->assign("templateType", "TwoColLeft");  //OneCol, TwoColLeft, TwoColRight
  $smarty->assign("contents", $contents);
  $smarty->assign("sidebar", $sidebar);
  $smarty->assign("ajax", $js);
  $smarty->display('settings.tpl');
?>

