<?
/*********************** INCLUDES *********************************************/
  $includePath=realpath(dirname(__FILE__)."/../");
  require_once ($includePath.'/config/cfg.php');
  //require($includePath.'/constants.php');
  require_once ($includePath.'/lib/phpagi/phpagi.php');
  //require($includePath.'/agi/agifunction.php');
/*********************** INITIALIZATION ***************************************/

  $agi = new AGI();
  // Get AGI parameters 
  // (WARNING: GET array may be null in many cases, parseArgv take $_SERVER content) 
  parse_str($_SERVER["argv"][1], $var_GET); 
  if(isset($var_GET["rule"])) $triggeredRuleId=$var_GET["rule"];
  else $triggeredRuleId=0;
  if(isset($var_GET["entity"])) $triggeredEntityId=$var_GET["entity"];
  else $triggeredEntityId=0;
  if(isset($var_GET["answered"])) $triggeredAnswered=$var_GET["answered"];
  else $triggeredAnswered=0;
  if(isset($var_GET["channel"])) $triggeredChannelId=$var_GET["channel"];
  else $triggeredChannelId=0;
  // Extract caller Id
  $triggeredCallerid=$agi->get_variable("CALLERID(num)");
  $triggeredCallerid=$triggeredCallerid["data"];
  preg_match("/(?:\"(.*)\"|(\s*))\s*(?:\<(.*)\>|(.*))/", $triggeredCallerid, $matches);
  $triggeredCallername = $matches[1];
  if ($matches[3]) $triggeredCallerid = $matches[3];
  else if ($matches[4]) $triggeredCallerid = $matches[4];
  else $triggeredCallerid = "ANONYMOUS";
  $triggeredChannel=$agi->get_variable("CHANNEL");
  $triggeredChannel=$triggeredChannel["data"];
  agiError("-----------------------------------------------");
  agiError("Incoming Rule Set: [$triggeredRuleId] (callerid: $triggeredCallerid)");
  agiError("-----------------------------------------------");
  
/*********************** PAGE LOGIC ********************************************/
  //Extract call type and called number
  $callInfo=_getCallInfo($triggeredChannel);
  switch($callInfo["channelTech"]){
    case SIP:
      // retrieve provider information
      if(($triggeredChannelId!=0)&&($callInfo["calledNumber"]!="")){ 
        $accountInfo=_getCalledAccount($triggeredChannelId,$callInfo["calledNumber"]);
        if(is_array($accountInfo)){
          agiError("   ACCOUNT: [".$accountInfo["id"]."] ".$accountInfo["name"]." on ch.".$accountInfo["channel"]." (".$accountInfo["msns"].")");
          agiError("   RULESET: [".$accountInfo["rule"]."] matching context \"".$triggeredAnswered."\"");
          //set correct incoming channel
          $triggeredChannelId=$accountInfo["channel"];
          $triggeredEntityId="";
          $triggeredRuleId=$accountInfo["rule"];
        }else agiError("   ACCOUNT: UNDEFINED INCOMIG NUMBER (".$callInfo["calledNumber"].")");   
      }else agiError("   ACCOUNT: UNABLE TO RETRIEVE INFORMATION (called number is null)");
    break;
    default:
      agiError("ANSWERED: ".$triggeredAnswered." on channel ".$triggeredChannel);
    break;
  }
  /*
  $retrievedCalledChannel=$agi->get_variable("CHANNEL");
  $retrievedCalledChannelArr=split("/",$retrievedCalledChannel["data"]);
  if((is_array($retrievedCalledChannelArr))&&($retrievedCalledChannelArr[0]=="SIP")){
    $sipToHeader=$agi->get_variable("SIP_HEADER(TO)");
    $sipFromHeader=$agi->get_variable("SIP_HEADER(FROM)");
    if($sipToHeader["data"]!=""){ 
      $sipTo=substr($sipToHeader["data"], 0, strpos($sipToHeader["data"], ">")).">";
      $sipFrom=substr($sipFromHeader["data"], 0, strpos($sipFromHeader["data"], ">")).">";
      agiError("[SIP CALL]");
      agiError("   FROM: ".$sipFrom);
      agiError("   TO: ".$sipTo);
      $isVoipCall=true;
      $channelTech=SIP;
    }else{
      $isVoipCall=false;
      $incomingTech=0;
    }
  }else{
    $isVoipCall=false;
    $incomingTech=0;
  }
  // VOIP CALL: retrieve provider account
  if($isVoipCall===true){
    // retrieve called number
    if($channelTech==SIP){
      $calledNumber=substr($sipTo, (strpos($sipTo,":") + 1), ((strpos($sipTo,"@")) - (strpos($sipTo,":")) - 1));
    }
    // retrieve provider information
    if(($triggeredChannelId!=0)&&($calledNumber!="")){ 
      $calledMatch=false;   
      //verify type
      $qry="SELECT ch.* , en.`type` ";
      $qry.="FROM `cw_channel` AS ch JOIN `cw_entity` AS en ON ch.`key` = en.`id` ";
      $qry.="WHERE ch.`id`=$triggeredChannelId";
      $res=$db->Execute($qry);
      if($res!==false){ 
        $ch=$res->FetchRow();
        if($ch["type"]==PROVIDER_ACCOUNT){
          //get all relative provider's accounts
          $qry="SELECT * ";
          $qry.="FROM `cw_provider_account` AS pa JOIN `cw_channel` AS ch ON pa.`id` = ch.`key`";
          $qry.="WHERE pa.`provider`=(SELECT `provider` FROM `cw_provider_account` WHERE `id`=".$ch["key"].")";
          $res=$db->Execute($qry);
          //find called account
          while(($accArr=$res->FetchRow())&&($calledMatch===false)){
            $accNumbers=split("\|",$accArr["msns"]);
            if(is_array($accNumbers)){ 
              foreach($accNumbers as $accNumber){
                $calledMatch=_matchPattern($calledNumber,$accNumber);
                if($calledMatch===true){
                  $calledChannel=$accArr["id"];
                  $calledAccount=$accArr["key"];
                  $calledRule=$accArr["rule"];
                  agiError("   ACCOUNT: [".$calledAccount."] ".$accArr["name"]." on ch.".$calledChannel." (".$accArr["msns"].")");
                  agiError("   RULESET: [".$calledRule."] matching context \"".$triggeredAnswered."\"");
                  break;
                }
              }
            }
          }
        }
      }
      //set correct incoming channel
      if($calledMatch===true) {
        $triggeredChannelId=$calledChannel;
        $triggeredEntityId="";
        $triggeredRuleId=$calledRule;
      }  
      else agiError("   ACCOUNT: UNDEFINED INCOMIG NUMBER ($calledNumber)");
    }
  }else{
    $calledChannel=$retrievedCalledChannel;
    agiError("ANSWERED: ".$triggeredAnswered." on channel ".$calledChannel["data"]);
  }
  */
  // Process incoming call
  agiError("[ RULES ]");
  $canContinue=true;
  $qry="SELECT * FROM cw_rule_incoming WHERE rule=$triggeredRuleId ORDER BY priority";
  $res=$db->Execute($qry);
  while ($arr=$res->FetchRow()) {
    $id=$arr["id"];
    $rule=$arr["rule"];
    $priority=$arr["priority"];
    $timesegment=$arr["timesegment"];
    $callertype=$arr["callertype"];
    $callerid=$arr["callerid"];
    $channel=$arr["from_channel"];
    $number=$arr["from_number"];
    $numberArr=split("\|",$number);
    $macro=$arr["macro"];
    $parameter=$arr["parameter"];
    $duration=$arr["duration"];
    agiError("Rule: $id (Type:$callertype, callerid: $callerid, channel: $channel)");
    //fetch the entity type    
    if ($triggeredEntityId!="") {
      $qry="SELECT * FROM cw_channel WHERE `key`=$triggeredEntityId";
      $resT=$db->Execute($qry);
      $t=$resT->FetchRow();
      $channelId=$t["id"];
    } else $channelId=$triggeredChannelId;
    //check rule
    if  ( 
          (
            //(now we are in the rule's timesegment)
            (checkTime($timesegment)===true)
          )
          AND 
          (
            //(rule match callerid)
            (_isCallerIncluded($callerid,$callertype,$triggeredCallerid)===true)
          )
          AND 
          (
            //(rule match all numbers)
            ($number=="") OR 
            //(rule match some number) and (one of them is the triggered one)
            ($number!="" AND in_array($triggeredAnswered,$numberArr)) OR  
            // ??????????? some numbers are dialed and a catch all matched ????????????
            (in_array("X",$numberArr) AND $triggeredAnswered!="s" )  
          )
          AND
          (
            //(rule match all channels) or ((rule match a channel) and (it is the triggered one))
            (($channel==0) OR ($channel!=0 AND $channel==$channelId))
          ) 
          AND
          (
            //no rules has been triggered before
            ($canContinue===true)
          )
        )
    {
      agiError("  TRIGGERED RULE $id!");  
      // execute macro
      $arrMacro=prepareMacro($macro,$parameter);  
      agiError("  Executing macro ".$arrMacro[0].$arrMacro[1]." ...");
      $agi->exec("macro ".$arrMacro[0].$arrMacro[1]);
      /**
       * CALL FINDER
       *
      $incomingcallidArr=$agi->get_variable("UNIQUEID");
      $incomingcallid=$incomingcallidArr["data"];
      $qry="INSERT INTO `incomingcall` ( `id` , `caller_number` ) ";
      $qry.="VALUES ('".$incomingcallid."','".$triggeredCallerid."'); ";   
      $resT=$db->Execute($qry);     
       */
      // set canContinue
      if ($duration=="1") $canContinue=true; else $canContinue=false;
    }  
  }
  agiError("Exit from incoming.php");
      
?>
